lexer grammar DTD;
options {
  language=Java;

}

@rulecatch {
catch(RecognitionException e){
	Logger.getLogger(this.getClass()).warn(e);
}
}
@header {
//--------------------------------------------------
// Xerial -- Transactional XML Database System      
// 
// DTDLexer.g
// Since  2007/07/25 11:40:17
// 
//--------------------------------------------------

package org.xerial.util.xml.dtd.impl;
import org.xerial.util.log.Logger;

}

T__29 : '>' ;
T__30 : 'EMPTY' ;
T__31 : 'ANY' ;
T__32 : '?' ;
T__33 : '*' ;
T__34 : '+' ;
T__35 : '|' ;
T__36 : '#PCDATA' ;
T__37 : '<!ATTLIST' ;
T__38 : 'NOTATION' ;
T__39 : 'CDATA' ;
T__40 : 'ID' ;
T__41 : 'IDREF' ;
T__42 : 'IDREFS' ;
T__43 : 'ENTITY' ;
T__44 : 'ENTITIES' ;
T__45 : 'NMTOKEN' ;
T__46 : 'NMTOKENS' ;

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 69
ML_COMMENT
    :   '<!--' (options {greedy=false;} : .)* '-->' {$channel=HIDDEN;}
    ;

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 73
At: '@';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 74
Colon: ':';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 75
Comma: ',';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 76
Apos: '\'';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 77
Quot: '"';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 78
Dot: '.';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 79
SemiColon: ';';

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 81
LParen: '(';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 82
RParen: ')';

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 84
fragment Letter: 'a' .. 'z' | 'A' .. 'Z';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 85
fragment Digit: '0' .. '9';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 86
Digits: (Digit)+;

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 88
fragment NameChar: Letter | Digit | '_' | '-' | At;

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 90
WhiteSpaceChar: ( ' ' | '\t' | '\n' | '\r' | '\u000C')+ { $channel=HIDDEN; };

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 92
StringLiteral
: Quot! (~'"')* Quot!
| Apos! (~'\'')* Apos!;

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 96
Name: (Letter | '_') NameChar*;


// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 99
fragment AttValue: 
    Quot (~('<' | '&' | Quot) | Reference)* Quot 
    | Apos (~('<' | '&' | Apos) | Reference)* Apos 
	; 
	
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 104
Reference: EntityRef | CharRef;
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 105
fragment EntityRef: '&' Name SemiColon;
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 106
fragment CharRef: '&#' ('0'..'9')+ SemiColon | '&#x' ('0'..'9' | 'a'..'f' | 'A'..'F')+ SemiColon
	;
	
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 109
DefaultDecl: '#REQUIRED' | '#IMPLIED' | ('#FIXED'? AttValue); 

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\xerial\xerial-core\src\main\java\org\xerial\util\xml\dtd\impl\DTD.g" 111
Element: '<!ELEMENT';



